/**
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/NG-ZORRO/ng-zorro-antd/blob/master/LICENSE
 */
import { Platform } from '@angular/cdk/platform';
import { ChangeDetectorRef, ElementRef, EventEmitter, NgZone, OnChanges } from '@angular/core';
import { NzConfigKey, NzConfigService } from 'ng-zorro-antd/core/config';
import { NgClassInterface, NumberInput, NzShapeSCType, NzSizeLDSType } from 'ng-zorro-antd/core/types';
import * as i0 from "@angular/core";
export declare class NzAvatarComponent implements OnChanges {
    nzConfigService: NzConfigService;
    private elementRef;
    private cdr;
    private platform;
    private ngZone;
    static ngAcceptInputType_nzGap: NumberInput;
    readonly _nzModuleName: NzConfigKey;
    nzShape: NzShapeSCType;
    nzSize: NzSizeLDSType | number;
    nzGap: number;
    nzText?: string;
    nzSrc?: string;
    nzSrcSet?: string;
    nzAlt?: string;
    nzIcon?: string;
    readonly nzError: EventEmitter<Event>;
    hasText: boolean;
    hasSrc: boolean;
    hasIcon: boolean;
    classMap: NgClassInterface;
    customSize: string | null;
    textEl?: ElementRef<HTMLSpanElement>;
    private el;
    constructor(nzConfigService: NzConfigService, elementRef: ElementRef, cdr: ChangeDetectorRef, platform: Platform, ngZone: NgZone);
    imgError($event: Event): void;
    ngOnChanges(): void;
    private calcStringSize;
    private notifyCalc;
    private setSizeStyle;
    static ɵfac: i0.ɵɵFactoryDeclaration<NzAvatarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NzAvatarComponent, "nz-avatar", ["nzAvatar"], { "nzShape": { "alias": "nzShape"; "required": false; }; "nzSize": { "alias": "nzSize"; "required": false; }; "nzGap": { "alias": "nzGap"; "required": false; }; "nzText": { "alias": "nzText"; "required": false; }; "nzSrc": { "alias": "nzSrc"; "required": false; }; "nzSrcSet": { "alias": "nzSrcSet"; "required": false; }; "nzAlt": { "alias": "nzAlt"; "required": false; }; "nzIcon": { "alias": "nzIcon"; "required": false; }; }, { "nzError": "nzError"; }, never, never, false, never>;
}
